/* -*-mode:C++-*- */
/*
 * ksi_regexp.h
 * regexp ksi interface
 *
 * Copyright (C) 1998-2000, Ivan Demakov.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without a written
 * agreement is hereby granted, provided that the above copyright notice
 * and this paragraph and the following two paragraphs appear in all copies.
 * Modifications to this software may be copyrighted by their authors
 * and need not follow the licensing terms described here, provided that
 * the new terms are clearly indicated on the first page of each file where
 * they apply.
 *
 * IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
 * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
 * INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
 * DOCUMENTATION, EVEN IF THE AUTHORS HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAS NO OBLIGATIONS
 * TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 *
 *
 * Author:        Ivan Demakov <demakov@users.sourceforge.net>
 * Creation date: Sat Jul  4 06:35:44 1998
 * Last Update:   Sat Dec  2 04:00:30 2000
 *
 * 
 * $Id: ksi_regexp.h,v 1.2 2000/12/01 23:59:34 demakov Exp $
 *
 */

#ifndef KSI_REGEXP_H
#define KSI_REGEXP_H

#ifndef KSI_H
#  include "ksi.h"
#  include "ksi_type.h"
#endif

#if defined(__WATCOMC__)
#  if defined(MSWIN32)
#    if defined(KSIDLL)
#      if defined(MAKE_regexp_LIB)
#        define REGEXP_API extern __declspec(dllexport)
#      else
#        define REGEXP_API extern __declspec(dllimport)
#      endif
#    endif
#  endif
#endif

#if defined(_MSC_VER)
#  if defined(KSIDLL)
#    if defined(MAKE_regexp_LIB)
#      define REGEXP_API __declspec(dllexport)
#    else
#      define REGEXP_API __declspec(dllimport)
#    endif
#  endif
#endif

#ifndef REGEXP_API
#  define REGEXP_API extern
#endif


#ifdef __cplusplus
extern "C" {
#endif

REGEXP_API
void
ksi_init_regexp (void);

REGEXP_API
void
ksi_term_regexp (void);

REGEXP_API
ksi_obj
ksi_regexp_p (ksi_obj x);

REGEXP_API
ksi_obj
ksi_make_regexp (ksi_obj str, ksi_obj opt);

REGEXP_API
ksi_obj
ksi_regexp_exec (ksi_obj x, ksi_obj str, ksi_obj start, ksi_obj end);

REGEXP_API
ksi_obj
ksi_string_match (ksi_obj pattern, ksi_obj string, ksi_obj opt);


#ifdef __cplusplus
}
#endif


#endif

 /* End of file */
